/****************************************************************************
** Form implementation generated from reading ui file 'ui-files\client_dlg.ui'
**
** Created: Wed Oct 8 19:49:31 2003
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "client_dlg.h"
#include "prefs_dlg.h"
#include "../common/aoc_proc.h"
#include "../common/aoc_names.h"
#include "../common/aoc_version.h"
#include "skills.h"
#include <qaccel.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qtabwidget.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qurloperator.h>
#include <qgrid.h>
#include <qmessagebox.h>

#include "../pixmaps/AOCrafter.xpm"

#define NORESULT_DEFAULT "Select a process and desired QL, and click <b>GO</b><br>To calculate max QL, click <b>Preferences</b> to set your skills."

/* 
 *  Constructs a AOCrafterDialog which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
AOCrafterDialog::AOCrafterDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "AOCrafterDialog" );
    resize( 550, 450 );
    setCaption( tr( "AOCrafter v%1" ).arg( AOC_VERSION ) );
    QPixmap *icon = new QPixmap( AOCrafter_xpm );
    setIcon( *icon );
    setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, sizePolicy().hasHeightForWidth() ) );
	aocDebug( "AOCrafterDialog::AOCrafterDialog(): Creating GUI:" );
    BaseLayout = new QVBoxLayout( this ); 
    BaseLayout->setSpacing( 6 );
    BaseLayout->setMargin( 10 );

    Layout4 = new QGridLayout;
    Layout4->setSpacing( 6 );
    Layout4->setMargin( 0 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Groups Label..." );
    ProcGrpLabel = new QLabel( this, "ProcGrpLabel" );
    ProcGrpLabel->setText( tr( "Tradeskill Groups" ) );

    Layout4->addWidget( ProcGrpLabel, 0, 0 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Groups List..." );
    ProcGrpList = new QComboBox( FALSE, this, "ProcGrpList" );
    ProcGrpList->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Fixed, ProcGrpList->sizePolicy().hasHeightForWidth() ) );
    ProcGrpList->setCurrentItem( 0 );

    Layout4->addMultiCellWidget( ProcGrpList, 0, 0, 1, 3 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Process Label..." );
    ProcessLabel = new QLabel( this, "ProcessLabel" );
    ProcessLabel->setText( tr( "Tradeskill Process" ) );

    Layout4->addWidget( ProcessLabel, 1, 0 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Process List..." );
    ProcessList = new QComboBox( FALSE, this, "ProcessList" );
    ProcessList->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Fixed, ProcessList->sizePolicy().hasHeightForWidth() ) );

    Layout4->addMultiCellWidget( ProcessList, 1, 1, 1, 3 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Quality Label..." );
    QualityLabel = new QLabel( this, "QualityLabel" );
    QualityLabel->setText( tr( "Result Quality" ) );

    Layout4->addWidget( QualityLabel, 2, 0 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Quality Slider..." );
    QualitySlider = new QSlider( 1, 300, 10, 1, QSlider::Horizontal, this, "QualitySlider" );
    QualitySlider->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Fixed, QualitySlider->sizePolicy().hasHeightForWidth() ) );
	QualitySlider->setTickmarks( QSlider::Below );

    Layout4->addWidget( QualitySlider, 2, 1 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Quality Spinner..." );
	QualitySpin = new QSpinBox( 1, 300, 1, this, "QualitySpin" );
    QualitySpin->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, QualitySpin->sizePolicy().hasHeightForWidth() ) );
	QualitySpin->setFixedWidth( 60 );

	Layout4->addWidget( QualitySpin, 2, 2 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): - 'Max QL' Button..." );
	MaxQLButton = new QPushButton( this, "MaxQLButton" );
	MaxQLButton->setToggleButton( TRUE );
	MaxQLButton->setText( tr( "Max QL" ) );

	Layout4->addWidget( MaxQLButton, 2, 3 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  'GO' Button..." );
    GoButton = new QPushButton( this, "GoButton" );
    GoButton->setSizePolicy( QSizePolicy( QSizePolicy::Maximum, QSizePolicy::Minimum, GoButton->sizePolicy().hasHeightForWidth() ) );
	GoButton->setDefault( TRUE );
    QFont GoButton_font(  GoButton->font() );
    GoButton_font.setFamily( "Arial" );
    GoButton_font.setPointSize( 16 );
	GoButton_font.setWeight( QFont::Black );
    GoButton->setFont( GoButton_font ); 
    GoButton->setText( tr( "GO!" ) );

    Layout4->addMultiCellWidget( GoButton, 0, 2, 4, 4 );

    BaseLayout->addLayout( Layout4 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Results Controller..." );
	ResultCtrl = new QTabWidget( this, "ResultCtrl" );
	ResultCtrl->setMargin( 3 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Steps ScrollView..." );
	StepView = new QScrollView( this, "StepView" );
    StepView->setHScrollBarMode( QScrollView::AlwaysOff );
	StepView->setVScrollBarMode( QScrollView::AlwaysOn );
	StepView->viewport()->setBackgroundMode( PaletteMidlight );
	ResultCtrl->addTab( StepView, "Steps" );
	StepsList = NULL;

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Summary Box..." );
	SummaryBox = new QVBox( this );
	SummaryBox->setSpacing( 4 );
	SummaryBox->setMargin( 0 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Items Box..." );
	ItemsBox = new QVBox( SummaryBox, "ItemsBox" );
	ItemsBox->setSpacing( 0 );
	ItemsBox->setMargin( 0 );
	ItemsBox->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	ItemsBox->setLineWidth( 2 );
	ItemsBox->setFixedHeight( 116 );

	QHBox * ItemsHeadBox = new QHBox( ItemsBox, "ItemsHeadBox" );
	ItemsHeadBox->setSpacing( 0 );
	ItemsHeadBox->setMargin( 0 );

	QLabel * ItemsNameLabel = new QLabel( ItemsHeadBox, "ItemsNameLabel" );
	ItemsNameLabel->setText( "<b>Needed Items:</b>" );
	ItemsNameLabel->setFrameStyle( QFrame::Panel | QFrame::Raised );

	QLabel * ItemsValueLabel = new QLabel( ItemsHeadBox, "ItemsValueLabel" );
	ItemsValueLabel->setText( "<b>Quality:</b>" );
	ItemsValueLabel->setFrameStyle( QFrame::Panel | QFrame::Raised );
	ItemsValueLabel->setFixedWidth( 75 );

	QLabel * ItemsCountLabel = new QLabel( ItemsHeadBox, "ItemsCountLabel" );
	ItemsCountLabel->setText( "<b>Amount:</b>" );
	ItemsCountLabel->setFrameStyle( QFrame::Panel | QFrame::Raised );
	ItemsCountLabel->setFixedWidth( 76 );

	ItemsView = new QScrollView( ItemsBox, "ItemsView" );
    ItemsView->setHScrollBarMode( QScrollView::AlwaysOff );
	ItemsView->setVScrollBarMode( QScrollView::AlwaysOn );
	ItemsView->setLineWidth( 0 );
	ItemsView->setFixedHeight( 91 );
	ItemsView->viewport()->setBackgroundMode( PaletteMidlight );
	ItemsList = NULL;

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Items Note..." );
	NoteLabel = new QLabel( SummaryBox, "NoteLabel" );
	NoteLabel->setText( tr( "QL's marked with a <b>*</b> (star) are fixed, meaning they only exist at this value.<br>Item counts in parentheses indicate reusable tools. All other items are consumed" ) );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  Skills Box..." );
	SkillsBox = new QVBox( SummaryBox, "SkillsBox" );
	SkillsBox->setSpacing( 0 );
	SkillsBox->setMargin( 0 );
	SkillsBox->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	SkillsBox->setLineWidth( 2 );
	SkillsBox->setFixedHeight( 116 );

	QHBox * SkillsHeadBox = new QHBox( SkillsBox, "SkillsHeadBox" );
	SkillsHeadBox->setSpacing( 0 );
	SkillsHeadBox->setMargin( 0 );

	QLabel * SkillsNameLabel = new QLabel( SkillsHeadBox, "SkillsNameLabel" );
	SkillsNameLabel->setText( "<b>Needed Skills:</b>" );
	SkillsNameLabel->setFrameStyle( QFrame::Panel | QFrame::Raised );

	QLabel * SkillsValueLabel = new QLabel( SkillsHeadBox, "SkillsValueLabel" );
	SkillsValueLabel->setText( "<b>Amount:</b>" );
	SkillsValueLabel->setFrameStyle( QFrame::Panel | QFrame::Raised );
	SkillsValueLabel->setFixedWidth( 76 );

	SkillsView = new QScrollView( SkillsBox, "SkillsView" );
    SkillsView->setHScrollBarMode( QScrollView::AlwaysOff );
	SkillsView->setVScrollBarMode( QScrollView::AlwaysOn );
	SkillsView->setLineWidth( 0 );
	SkillsView->setFixedHeight( 91 );
	SkillsView->viewport()->setBackgroundMode( PaletteMidlight );
	SkillsList = NULL;

	ResultCtrl->addTab( SummaryBox, "Summary" );
	ResultCtrl->hide();

	BaseLayout->addWidget( ResultCtrl );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  NoResult label..." );
	NoResultLabel = new QLabel( this, "NoResultLabel" );
    QFont LargeFont( NoResultLabel->font() );
    LargeFont.setFamily( "Arial" );
    LargeFont.setPointSize( 12 );
    NoResultLabel->setFont( LargeFont ); 
	NoResultLabel->setText( NORESULT_DEFAULT );
	NoResultLabel->setFrameStyle( QFrame::Panel | QFrame::Raised );
	NoResultLabel->setLineWidth( 2 );
	NoResultLabel->setAlignment( Qt::AlignCenter );
	BaseLayout->addWidget( NoResultLabel );

    Layout1 = new QHBoxLayout; 
    Layout1->setSpacing( 6 );
    Layout1->setMargin( 0 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  'Prefs' Button..." );
    PrefsButton = new QPushButton( this, "PrefsButton" );
    PrefsButton->setText( tr( "&Preferences" ) );
    PrefsButton->setAutoDefault( FALSE );
    Layout1->addWidget( PrefsButton );

	QAccel * PrefsAccel = new QAccel( this );
	PrefsAccel->connectItem( PrefsAccel->insertItem( Key_F1 ), this, SLOT( prefsClicked() ) );

    QSpacerItem* spacer_3 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( spacer_3 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): -  'Exit' Button..." );
    ExitButton = new QPushButton( this, "ExitButton" );
    ExitButton->setCaption( tr( "" ) );
    ExitButton->setText( tr( "&Exit" ) );
    Layout1->addWidget( ExitButton );
    BaseLayout->addLayout( Layout1 );

	aocDebug( "AOCrafterDialog::AOCrafterDialog(): GUI Done" );

    // signals and slots connections
    connect( GoButton, SIGNAL( clicked() ), this, SLOT( goClicked() ) );
    connect( PrefsButton, SIGNAL( clicked() ), this, SLOT( prefsClicked() ) );
	connect( MaxQLButton, SIGNAL( toggled(bool) ), this, SLOT( maxQLToggled(bool) ) );
    connect( ExitButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( ProcGrpList, SIGNAL( activated(int) ), this, SLOT( procGrpChanged(int) ) );
    connect( ProcessList, SIGNAL( activated(int) ), this, SLOT( processChanged(int) ) );
	connect( QualitySlider, SIGNAL( valueChanged(int) ), this, SLOT( qualityChanged(int) ) );
	connect( QualitySpin, SIGNAL( valueChanged(int) ), this, SLOT( qualityChanged(int) ) );

    // tab order
    setTabOrder( ProcGrpList, ProcessList );
    setTabOrder( ProcessList, QualitySlider );
	setTabOrder( QualitySlider, QualitySpin );
    setTabOrder( QualitySpin, MaxQLButton );
	setTabOrder( MaxQLButton, PrefsButton );
    setTabOrder( PrefsButton, ExitButton );

	// "What's this?" texts
    QWhatsThis::add( ProcGrpList, tr( "Select the tradeskill group you wish to use.\nBe sure to select the right process type aswell, before pressing \"Go\"." ) );
    QWhatsThis::add( ProcessList, tr( "Select the type of the process you wish to use (The tradeskill group might only contain 1 process type)." ) );
    QWhatsThis::add( QualitySlider, tr( "Select the quality of the tradeskill product." ) );
    QWhatsThis::add( QualitySpin, tr( "Select the quality of the tradeskill product." ) );
	QWhatsThis::add( MaxQLButton, tr( "Calculates the max product you can make based on your skills (Note: Check the \"My Skills\" tab in the preferences dialog to set your skills). " ) );
    QWhatsThis::add( GoButton, tr( "Calculates the needed tools, items and skills required to complete the selected tradeskill process." ) );

	updateProcGrpList();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
AOCrafterDialog::~AOCrafterDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*  
 *  Main event handler. Reimplemented to handle application
 *  font changes
 */
bool AOCrafterDialog::event( QEvent* ev )
{
    bool ret = QDialog::event( ev ); 
    if ( ev->type() == QEvent::ApplicationFontChange )
	{
		QFont LargeFont( GoButton->font() );
		LargeFont.setFamily( "Arial" );
		LargeFont.setPointSize( 16 );
		LargeFont.setWeight( QFont::Black );
		GoButton->setFont( LargeFont ); 
		LargeFont = QFont( NoResultLabel->font() );
		LargeFont.setFamily( "Arial" );
		LargeFont.setPointSize( 12 );
		NoResultLabel->setFont( LargeFont );
    }
    return ret;
}

void AOCrafterDialog::updateProcGrpList()
{
	ProcGrpList->clear();
	if( Procs.getProcGroups() )
	{
		for( int n = 0; n < Procs.getProcGroups(); n++ )
		{
			ProcGrpList->insertItem( Procs.getProcGroup( n ) );
		}
	}
	if( Procs.getProcGroups() <= 1 )
	{
		ProcGrpList->setEnabled( FALSE );
	}
	else
	{
		ProcGrpList->setEnabled( TRUE );
	}
	updateProcList();
}

void AOCrafterDialog::updateProcList()
{
	ProcessList->clear();
	Procs.setProcGroup( ProcGrpList->currentItem() );
	if( Procs.getProcesses() )
	{
		for( int n = 0; n < Procs.getProcesses(); n++ )
		{
			ProcessList->insertItem( Procs.getProcess( n ).Name );
		}
	}
	if( Procs.getProcesses() <= 1 )
	{
		ProcessList->setEnabled( FALSE );
	}
	else
	{
		ProcessList->setEnabled( TRUE );
	}
	processChanged( 0 );
}

void AOCrafterDialog::procGrpChanged(int)
{
	updateProcList();
}

void AOCrafterDialog::processChanged(int)
{
	AOCProc selProc;
	Procs.setProcGroup( ProcGrpList->currentItem() );
	selProc = Procs.getProcess( ProcessList->currentItem() );
	int tmpQl = QualitySlider->value();

	aocDebug( "AOCrafterDialog::processChanged(): Selected: %s (ql %d-%d)",
		selProc.Name.latin1(), selProc.MinQL, selProc.MaxQL );
	QualitySlider->setMinValue( selProc.MinQL );
	QualitySlider->setMaxValue( selProc.MaxQL );
	QualitySpin->setMinValue( selProc.MinQL );
	QualitySpin->setMaxValue( selProc.MaxQL );
	if( tmpQl > selProc.MaxQL )
		tmpQl = selProc.MaxQL;
	else if( tmpQl < selProc.MinQL )
		tmpQl = selProc.MinQL;
	qualityChanged( tmpQl );
	if( selProc.MaxQL == selProc.MinQL )
	{
		QualitySlider->setEnabled( FALSE );
		QualitySpin->setEnabled( FALSE );
		QualitySpin->setSpecialValueText( "Special" );
		MaxQLButton->setEnabled( FALSE );
		MaxQLButton->setOn( FALSE );
	}
	else
	{
		QualitySlider->setEnabled( TRUE );
		QualitySpin->setEnabled( TRUE );
		QualitySpin->setSpecialValueText( "" );
		MaxQLButton->setEnabled( TRUE );
	}
	maxQLToggled( 0 );
}

void AOCrafterDialog::maxQLToggled( bool )
{
	if( MaxQLButton->isOn() )
	{
		QualitySlider->setEnabled( FALSE );
		QualitySpin->setEnabled( FALSE );
	}
	else
	{
		QualitySlider->setEnabled( TRUE );
		QualitySpin->setEnabled( TRUE );
	}
}

void AOCrafterDialog::qualityChanged( int QL )
{
	QualitySlider->setValue( QL );
	QualitySpin->setValue( QL );
}

void AOCrafterDialog::prefsClicked()
{
	AOCPrefsDlg PrefsDlg( this, 0, TRUE, Qt::WStyle_Customize | Qt::WStyle_DialogBorder | Qt::WStyle_Title | Qt::WStyle_SysMenu );
	PrefsDlg.exec();
}

void AOCrafterDialog::goClicked()
{
	Items.clear();
	Skills.clear();
	Steps.clear();
	NoResultLabel->setText( NORESULT_DEFAULT );

	if( MaxQLButton->isOn() )
		calcMax();
	else
		calcSet();

	aocDebug( "AOCrafterDialog::goClicked(): Trimming items and skills lists..." );

	Items = Procs.makeUnique( Items );
	Skills = Procs.makeUnique( Skills );

	Items = Procs.sortReqsList( Items );
	Skills = Procs.sortReqsList( Skills, TRUE, TRUE );

	if( Steps.count() )
	{
		ResultCtrl->show();
		NoResultLabel->hide();
		showResults();
	}
	else
	{
		ResultCtrl->hide();
		NoResultLabel->show();
	}
}

void AOCrafterDialog::calcSet()
{
	double QL = (double) QualitySlider->value();
	Procs.setProcGroup( ProcGrpList->currentItem() );
	aocDebug( "AOCrafterDialog::calcSet(): Calculating requirements for making a QL %d %s", (int) QL,
		Procs.getProcess( ProcessList->currentItem() ).Name.latin1() );
	aocDebug( "AOCrafterDialog::calcSet(): Steps to process: %d", Procs.getSteps() );

	for( int n = 0; n < Procs.getSteps(); n++ )
	{
		aocDebug( "AOCrafterDialog::calcSet():  Step %d:", n );

		aocDebug( "AOCrafterDialog::calcSet():   Calculating items..." );
		AOCStep Step = Procs.getStep( n );

		/* calculate min. QL for item 1 */
		if( Step.Source.Multiplier == -1 )
			Step.Source.Value = Procs.getItemByID( Step.Source.AOC_ID ).MinQL;
		else
			Step.Source.Value = QMAX( qRound( QL - ( QL * ( Step.Source.Multiplier / 100 ) ) ), 1 );
		aocDebug( "AOCrafterDialog::calcSet():    Source: Value=%d ( %d - ( %d * ( %d / 100 ) ) )",
			Step.Source.Value, (int) QL, (int) QL, (int) Step.Source.Multiplier );

		/* calculate min. QL for item 2 */
		if( Step.Target.Multiplier == -1 )
			Step.Target.Value = Procs.getItemByID( Step.Target.AOC_ID ).MinQL;
		else
			Step.Target.Value = QMAX( qRound( QL - ( QL * ( Step.Target.Multiplier / 100 ) ) ), 1 );
		aocDebug( "AOCrafterDialog::calcSet():    Target: Value=%d ( %d - ( %d * ( %d / 100 ) ) )",
			Step.Target.Value, (int) QL, (int) QL, (int) Step.Target.Multiplier );

		/* calculate min. QL for product */
		if( Step.Result.Multiplier == -1 )
			Step.Result.Value = Procs.getItemByID( Step.Result.AOC_ID ).MinQL;
		else
			Step.Result.Value = QMAX( qRound( QL - ( QL * ( Step.Result.Multiplier / 100 ) ) ), 1 );
		aocDebug( "AOCrafterDialog::calcSet():    Result: Value=%d ( %d - ( %d * ( %d / 100 ) ) )",
			Step.Result.Value, (int) QL, (int) QL, (int) Step.Result.Multiplier );

		/* check if items are a product of another step */
		if( Step.Source.Flags & AOC_RESOURCE )
		{
			Step.Source.Count = Step.Source.Flags & AOC_CONSUMED ? Step.Count : 0;
			Items.append( Step.Source );
		}
		if( Step.Target.Flags & AOC_RESOURCE )
		{
			Step.Target.Count = Step.Target.Flags & AOC_CONSUMED ? Step.Count : 0;
			Items.append( Step.Target );
		}

		aocDebug( "AOCrafterDialog::calcSet():   Calculating skills..." );
		for( int s = 0; s < (int) Step.Skills.count(); s++ )
		{
			Step.Skills[s].Value = QMAX( qRound( Step.Skills[s].Multiplier * Step.Target.Value ), 1 );
			aocDebug( "AOCrafterDialog::calcSet():     Skill %d: %d * %d = %d", s, (int) Step.Skills[s].Multiplier,
				Step.Target.Value, Step.Skills[s].Value );
			Skills.append( Step.Skills[s] );
		}

		Step.Skills = Procs.makeUnique( Step.Skills );
		Step.Skills = Procs.sortReqsList( Step.Skills, TRUE, TRUE );

		Steps.append( Step );
	}
}

void AOCrafterDialog::calcMax()
{
	Procs.setProcGroup( ProcGrpList->currentItem() );
	AOCProc thisProc = Procs.getProcess( ProcessList->currentItem() );

	aocDebug( "AOCrafterDialog::calcMax(): Making info box..." );
	QMessageBox* mb = new QMessageBox( "Calculating...",
		tr( "Calculating maximum QL of %1 based on your skills." ).arg( thisProc.Name.latin1() ),
		QMessageBox::NoIcon, 0, 0, 0, this, "CalcMaxMB", FALSE );
	mb->show();

	aocDebug( "AOCrafterDialog::calcMax(): Calculating requirements for making a max QL %s",
		thisProc.Name.latin1() );
	aocDebug( "AOCrafterDialog::calcMax(): Steps to process: %d", Procs.getSteps() );

	aocDebug( "AOCrafterDialog::calcMax(): Verifying set skills..." );
	for( int m = 0; m < Procs.getSteps(); m++ )
	{
		AOCStep Step = Procs.getStep( m );
		for( int t = 0; t < (int) Step.Skills.count(); t++ )
		{
			AOCReq thisSkill = Step.Skills[t];
			aocDebug( "AOCrafterDialog::calcMax(): Checking skill #%d: %s",
				thisSkill.AOC_ID, Names.getSkill( thisSkill.AOC_ID ).latin1() );
			if( MySkills.getSkillByID( Step.Skills[t].AOC_ID ).Value == 0 )
			{
				NoResultLabel->setText( tr( "Failed to calculate max QL for process \"%1\":<br>Skill \"%3\" is not set!<br><br>" NORESULT_DEFAULT
					).arg( thisProc.Name ).arg( Names.getSkill( thisSkill.AOC_ID ) ) );
				mb->hide();
				return;
			}
		}
	}

	aocDebug( "AOCrafterDialog::calcMax(): All skills set." );

	bool isOk = TRUE;
	for( double QL = (double) thisProc.MaxQL; QL > 0; QL-- )
	{
		aocDebug( "AOCrafterDialog::calcMax(): QL is %d", (int) QL );
		for( int n = Procs.getSteps() - 1; n >= 0; n-- )
		{
			aocDebug( "AOCrafterDialog::calcMax():  Step %d:", n);

			aocDebug( "AOCrafterDialog::calcMax():   Calculating items..." );
			AOCStep Step = Procs.getStep( n );

			// calculate min. QL for item 1 //
			if( Step.Source.Multiplier == -1 )
				Step.Source.Value = Procs.getItemByID( Step.Source.AOC_ID ).MinQL;
			else
				Step.Source.Value = QMAX( qRound( QL - ( QL * ( Step.Source.Multiplier / 100 ) ) ), 1 );
			aocDebug( "AOCrafterDialog::calcMax():    Source: Value=%d ( %d - ( %d * ( %d / 100 ) ) )",
				Step.Source.Value, (int) QL, (int) QL, (int) Step.Source.Multiplier );

			// calculate min. QL for item 2 //
			if( Step.Target.Multiplier == -1 )
				Step.Target.Value = Procs.getItemByID( Step.Target.AOC_ID ).MinQL;
			else
				Step.Target.Value = QMAX( qRound( QL - ( QL * ( Step.Target.Multiplier / 100 ) ) ), 1 );
			aocDebug( "AOCrafterDialog::calcMax():    Target: Value=%d ( %d - ( %d * ( %d / 100 ) ) )",
				Step.Target.Value, (int) QL, (int) QL, (int) Step.Target.Multiplier );

			// calculate min. QL for product //
			if( Step.Result.Multiplier == -1 )
				Step.Result.Value = Procs.getItemByID( Step.Result.AOC_ID ).MinQL;
			else
				Step.Result.Value = QMAX( qRound( QL - ( QL * ( Step.Result.Multiplier / 100 ) ) ), 1 );
			aocDebug( "AOCrafterDialog::calcMax():    Result: Value=%d ( %d - ( %d * ( %d / 100 ) ) )",
				Step.Result.Value, (int) QL, (int) QL, (int) Step.Result.Multiplier );

			// check if items are a product of another step //
			if( Step.Source.Flags & AOC_RESOURCE )
			{
				Step.Source.Count = Step.Source.Flags & AOC_CONSUMED ? Step.Count : 0;
				Items.append( Step.Source );
			}
			if( Step.Target.Flags & AOC_RESOURCE )
			{
				Step.Target.Count = Step.Target.Flags & AOC_CONSUMED ? Step.Count : 0;
				Items.append( Step.Target );
			}

			aocDebug( "AOCrafterDialog::calcMax():   Calculating skills..." );
			for( int s = 0; s < (int) Step.Skills.count(); s++ )
			{
				Step.Skills[s].Value = QMAX( qRound( Step.Skills[s].Multiplier * Step.Target.Value ), 1 );
				aocDebug( "AOCrafterDialog::calcMax():     Skill %d: %d * %d = %d", s, (int) Step.Skills[s].Multiplier,
					Step.Target.Value, Step.Skills[s].Value );

				aocDebug( "AOCrafterDialog::calcMax(): Testing: %d > %d?",
					Step.Skills[s].Value, MySkills.getSkillByID( Step.Skills[s].AOC_ID ).Value );
				if( Step.Skills[s].Value > MySkills.getSkillByID( Step.Skills[s].AOC_ID ).Value )
				{
					isOk = FALSE;
					aocDebug( "AOCrafterDialog::calcMax(): isOk = FALSE" );
					break;
				}
				else
				{
					isOk = TRUE;
					aocDebug( "AOCrafterDialog::calcMax(): isOk = TRUE" );
				}

				Skills.append( Step.Skills[s] );
			}

			if( isOk == FALSE )
				break;

			Step.Skills = Procs.makeUnique( Step.Skills );
			Step.Skills = Procs.sortReqsList( Step.Skills, TRUE, TRUE );

			Steps.prepend( Step );
		}
		if( isOk == TRUE )
		{
			mb->hide();
			return;
		}
		else
		{
			Items.clear();
			Skills.clear();
			Steps.clear();
		}
	}
	NoResultLabel->setText( tr( "Max QL calculation failed!<br>Check your skills!<br><br>" NORESULT_DEFAULT ) );
	mb->hide();
}

void AOCrafterDialog::showResults()
{
	aocDebug( "AOCrafterDialog::showResults(): Setting up steps window..." );
	aocDebug( "AOCrafterDialog::showResults(): Reseting: StepsList" );
	if( StepsList != NULL )
		StepsList->~QVBox();
	StepsList = NULL;
	StepsList = new QVBox( StepView->viewport() );
	StepView->addChild( StepsList );

	for( int n = 0; n < (int) Steps.count(); n++ )
	{
		AOCStepWidget *stepW = new AOCStepWidget( StepsList );
		stepW->setStep( Steps[n], n );
	}
	StepView->showChild( StepsList, TRUE );

	aocDebug( "AOCrafterDialog::showResults(): Setting up summary window..." );

	aocDebug( "AOCrafterDialog::showResults(): Reseting: ItemsList" );
	if( ItemsList != NULL )
		ItemsList->~QGrid();
	ItemsList = NULL;
	ItemsList = new QGrid( 3, ItemsView->viewport() );
	ItemsList->setFixedWidth( 500 );
	ItemsList->setFixedHeight( Items.count() * 21 );
	ItemsView->addChild( ItemsList );

	for( int i = 0; i < (int) Items.count(); i++ )
	{
		QLabel * tmpItemName = new QLabel( ItemsList );
		tmpItemName->setText( QString( "<font color=darkblue><b>%1</b></font>" ).arg( Procs.getItemByID( Items[i].AOC_ID ).Name ) );
		tmpItemName->setMargin( 1 );
		if( i & 1 )
			tmpItemName->setBackgroundColor( QColor( "#EEE" ) );
		else
			tmpItemName->setBackgroundColor( QColor( "#FFF" ) );

		QLabel * tmpItemValue = new QLabel( ItemsList );
		if( Items[i].Multiplier == -1 )
			tmpItemValue->setText( QString( "%1 *" ).arg( Procs.getItemByID( Items[i].AOC_ID ).MinQL ) );
		else if( Items[i].Value == Procs.getItemByID( Items[i].AOC_ID ).MaxQL )
			tmpItemValue->setText( QString( "%1" ).arg( Items[i].Value ) );
		else
			tmpItemValue->setText( QString( "%1 - %2" ).arg( Items[i].Value ).arg( Procs.getItemByID( Items[i].AOC_ID ).MaxQL ) );
		tmpItemValue->setFixedWidth( 75 );
		tmpItemValue->setAlignment( Qt::AlignCenter );
		if( i & 1 )
			tmpItemValue->setBackgroundColor( QColor( "#CDE" ) );
		else
			tmpItemValue->setBackgroundColor( QColor( "#DEF" ) );

		QLabel * tmpItemCount = new QLabel( ItemsList );
		if( Items[i].Count > 0 )
			tmpItemCount->setText( QString( "%1" ).arg( Items[i].Count ) );
		else
			tmpItemCount->setText( QString( "(1)" ) );
		tmpItemCount->setFixedWidth( 60 );
		tmpItemCount->setAlignment( Qt::AlignCenter );
		if( i & 1 )
			tmpItemCount->setBackgroundColor( QColor( "#EEE" ) );
		else
			tmpItemCount->setBackgroundColor( QColor( "#FFF" ) );
	}
	ItemsView->showChild( ItemsList, TRUE );

	aocDebug( "AOCrafterDialog::showResults(): Reseting: SkillsList" );
	if( SkillsList != NULL )
		SkillsList->~QGrid();
	SkillsList = NULL;
	SkillsList = new QGrid( 2, SkillsView->viewport() );
	SkillsList->setFixedWidth( 500 );
	SkillsList->setFixedHeight( Skills.count() * 21 );
	SkillsView->addChild( SkillsList );

	for( int s = 0; s < (int) Skills.count(); s++ )
	{
		QLabel * tmpItemName = new QLabel( SkillsList );
		tmpItemName->setText( QString( "<font color=darkblue><b>%1</b></font>" ).arg( Names.getSkill( Skills[s].AOC_ID ) ) );
		tmpItemName->setMargin( 1 );
		if( s & 1 )
			tmpItemName->setBackgroundColor( QColor( "#EEE" ) );
		else
			tmpItemName->setBackgroundColor( QColor( "#FFF" ) );

		QLabel * tmpItemValue = new QLabel( SkillsList );
		tmpItemValue->setText( QString( "%1" ).arg( Skills[s].Value ) );
		tmpItemValue->setFixedWidth( 60 );
		tmpItemValue->setAlignment( Qt::AlignCenter );
		if( s & 1 )
			tmpItemValue->setBackgroundColor( QColor( "#CDE" ) );
		else
			tmpItemValue->setBackgroundColor( QColor( "#DEF" ) );
	}
	SkillsView->showChild( SkillsList, TRUE );
}



/*******************************************************************************************\
|*******************************************************************************************|
\*******************************************************************************************/


/* 
 *  Constructs a AOCStepWidget which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
AOCStepWidget::AOCStepWidget( QWidget* parent,  const char* name, WFlags fl )
    : QVBox( parent, name, fl )
{
	aocDebug( "AOCStepWidget::AOCStepWidget(): Making Step Widget" );
	setFrameStyle( QFrame::Panel | QFrame::Raised );
	setLineWidth( 2 );
	setFixedSize( 500, 120 );
	setSpacing( 4 );
	setMargin( 4 );

	StepLabel = new QLabel( this, "StepLabel" );
	StepLabel->setText( "<i>Step n:</i>" );

	StepBox = new QGrid( 3, this, "StepBox" );
	StepBox->setSpacing( 4 );
	StepBox->setMargin( 0 );

	QLabel* TempLabel = new QLabel( StepBox );
	TempLabel->setFixedWidth( 15 );

	SourceLabel = new QLabel( StepBox, "SourceLabel" );
	SourceLabel->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	SourceLabel->setText( "<b>Source</b>" );

	SourceQlLabel = new QLabel( StepBox, "SourceQlLabel" );
	SourceQlLabel->setFixedWidth( 75 );
	SourceQlLabel->setAlignment( Qt::AlignCenter );
	SourceQlLabel->setText( "<i>Ql</i>" );

	TempLabel = new QLabel( StepBox );
	TempLabel->setFixedWidth( 15 );
	TempLabel->setAlignment( Qt::AlignCenter );
	TempLabel->setText( "<font size=5><b>+</b></font>" );

	TargetLabel = new QLabel( StepBox, "TargetLabel" );
	TargetLabel->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	TargetLabel->setText( "<b>Target</b>" );

	TargetQlLabel = new QLabel( StepBox, "TargetQlLabel" );
	TargetQlLabel->setFixedWidth( 75 );
	TargetQlLabel->setAlignment( Qt::AlignCenter );
	TargetQlLabel->setText( "<i>Ql</i>" );

	TempLabel = new QLabel( StepBox );
	TempLabel->setFixedWidth( 15 );
	TempLabel->setAlignment( Qt::AlignCenter );
	TempLabel->setText( "<font size=5><b>=</b></font>" );

	ResultLabel = new QLabel( StepBox, "ResultLabel" );
	ResultLabel->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	ResultLabel->setText( "<b>Result</b>" );

	ResultQlLabel = new QLabel( StepBox, "ResultQlLabel" );
	ResultQlLabel->setFixedWidth( 75 );
	ResultQlLabel->setAlignment( Qt::AlignCenter );
	ResultQlLabel->setText( "<i>Ql</i>" );

	NoteLabel = new QLabel( this, "NoteLabel" );

	SkillsBox = new QGrid( 2, this, "SkillsBox" );
	SkillsBox->setSpacing( 0 );
	SkillsBox->setMargin( 0 );
	SkillsBox->setFrameStyle( QFrame::Panel | QFrame::Sunken );

	QLabel* SkillLabel = new QLabel( SkillsBox, "SkillLabel" );
	SkillLabel->setText( "<b>Skills:</b>" );
	SkillLabel->setFrameStyle( QFrame::Panel | QFrame::Raised );

	QLabel* ValueLabel = new QLabel( SkillsBox, "ValueLabel" );
	ValueLabel->setText( "<b>Value:</b>" );
	ValueLabel->setFrameStyle( QFrame::Panel | QFrame::Raised );

	QToolTip::add( SourceLabel, "Items listed in <b><font color=red>red</font></b> are consumed.<br>Items in <b><font color=darkgreen>green</font></b> are kept." );
	QToolTip::add( TargetLabel, "Items listed in <b><font color=red>red</font></b> are consumed.<br>Items in <b><font color=darkgreen>green</font></b> are kept." );
	QToolTip::add( ResultLabel, "Items listed in <b><font color=red>red</font></b> are consumed.<br>Items in <b><font color=darkgreen>green</font></b> are kept." );

	aocDebug( "AOCStepWidget::AOCStepWidget(): Done" );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
AOCStepWidget::~AOCStepWidget()
{
    // no need to delete child widgets, Qt does it all for us
}

void AOCStepWidget::setStep( AOCStep Step, int n = 0 )
{
	int AddHeight = 0;
	QString TextColor;

	/* Print out step label, incluting repeat count */
	QString Repeats = "";
	if( Step.Count > 1 ) Repeats = QString( "<font color=red>Repeat %1 times!</font>" ).arg( Step.Count );
	StepLabel->setText( QString( "<b><i>Step %1:  %2</i></b>" ).arg( n + 1 ).arg( Repeats ) );

	/* Print out source item information */
	if( Step.Source.Flags & AOC_CONSUMED )
		TextColor = "red";
	else
		TextColor = "darkgreen";
	SourceLabel->setText( QString( "<font color=%1><b>%2</b></font>"
		).arg( TextColor ).arg( Procs.getItemByID( Step.Source.AOC_ID ).Name ) );

	if( Step.Source.Multiplier == -1 )
		SourceQlLabel->setText( QString( "<font color=darkblue>Fixed QL %1</font>" ).arg( Step.Source.Value ) );
	else if( Step.Source.Value == Procs.getItemByID( Step.Source.AOC_ID ).MaxQL )
		SourceQlLabel->setText( QString( "<font color=darkblue>QL %1</font>" ).arg( Step.Source.Value ) );
	else
		SourceQlLabel->setText( QString( "<font color=darkblue>QL %1 - %2</font>" ).arg( Step.Source.Value ).arg( Procs.getItemByID( Step.Source.AOC_ID ).MaxQL ) );

	/* Print out target item information */
	if( Step.Target.Flags & AOC_CONSUMED )
		TextColor = "red";
	else
		TextColor = "darkgreen";
	TargetLabel->setText( QString( "<font color=%1><b>%2</b></font>"
		).arg( TextColor ).arg( Procs.getItemByID( Step.Target.AOC_ID ).Name ) );

	if( Step.Target.Multiplier == -1 )
		TargetQlLabel->setText( QString( "<font color=darkblue>Fixed QL %1</font>" ).arg( Step.Target.Value ) );
	else if( Step.Target.Value == Procs.getItemByID( Step.Target.AOC_ID ).MaxQL )
		TargetQlLabel->setText( QString( "<font color=darkblue>QL %1</font>" ).arg( Step.Target.Value ) );
	else
		TargetQlLabel->setText( QString( "<font color=darkblue>QL %1 - %2</font>" ).arg( Step.Target.Value ).arg( Procs.getItemByID( Step.Target.AOC_ID ).MaxQL ) );

	/* Print out result item information */
	ResultLabel->setText( QString( "<font color=darkgreen><b>%1</b></font>"
		).arg( Procs.getItemByID( Step.Result.AOC_ID ).Name ) );

	if( Step.Result.Multiplier == -1 )
		ResultQlLabel->setText( QString( "<font color=darkblue>Fixed QL %1</font>" ).arg( Step.Result.Value ) );
	else if( Step.Result.Value == Procs.getItemByID( Step.Result.AOC_ID ).MaxQL )
		ResultQlLabel->setText( QString( "<font color=darkblue>QL %1</font>" ).arg( Step.Result.Value ) );
	else
		ResultQlLabel->setText( QString( "<font color=darkblue>QL %1 - %2</font>" ).arg( Step.Result.Value ).arg( Procs.getItemByID( Step.Target.AOC_ID ).MaxQL ) );

	/* Add note */
	if( !Step.Note.isEmpty() )
	{
		NoteLabel->setText( QString( "<font color=red><i>Note: %1</i></font>" ).arg( Step.Note ) );
	}
	else
	{
		NoteLabel->hide();
		AddHeight -= 21;
	}

	aocDebug( "AOCStepWidget::AOCStepWidget(): Step[%d].Skills.count() = %d", n, Step.Skills.count() );
	if( Step.Skills.count() == 0 )
	{
		setFixedHeight( 120 );
		SkillsBox->hide();
		if( Step.Note.isEmpty() )
		{
			NoteLabel->setText( QString( "<font color=blue><i>No skill requirements listed.</i></font>" ) );
			NoteLabel->show();
		}
	}
	else
	{
		AddHeight += ( Step.Skills.count() * 21 ) + 30;
		setFixedHeight( 120 + AddHeight );
		for( int s = 0; s < (int) Step.Skills.count(); s++ )
		{
			QLabel * tmpSkillName = new QLabel( SkillsBox, QString( "Skill%1Name" ).arg( s ) );
			tmpSkillName->setText( QString( "<font color=darkblue><b>%1</b></font>" ).arg( Names.getSkill( Step.Skills[s].AOC_ID ) ) );
			tmpSkillName->setMargin( 1 );
			if( s & 1 )
				tmpSkillName->setBackgroundColor( QColor( "#EEE" ) );
			else
				tmpSkillName->setBackgroundColor( QColor( "#FFF" ) );

			QLabel * tmpSkillValue = new QLabel( SkillsBox, QString( "Skill%1Value" ).arg( s ) );
			tmpSkillValue->setText( QString( "%1" ).arg( Step.Skills[s].Value ) );
			tmpSkillValue->setMargin( 1 );
			tmpSkillValue->setFixedWidth( 75 );
			tmpSkillValue->setAlignment( Qt::AlignCenter );
			if( s & 1 )
				tmpSkillValue->setBackgroundColor( QColor( "#CDE" ) );
			else
				tmpSkillValue->setBackgroundColor( QColor( "#DEF" ) );
		}
	}
}
