/****************************************************************************
** Form interface generated from reading ui file 'ui-files\client_dlg.ui'
**
** Created: Wed Oct 8 19:49:31 2003
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#ifndef CLIENT_DLG_H
#define CLIENT_DLG_H

#include <qvariant.h>
#include <qdialog.h>
#include <qvbox.h>

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QComboBox;
class QGroupBox;
class QLabel;
class QListView;
class QListViewItem;
class QPushButton;
class QSlider;
class QSpinBox;
class QScrollView;
class QTabWidget;
class QGrid;

#include "../common/aoc_proc.h"

class AOCrafterDialog : public QDialog
{ 
    Q_OBJECT

public:
    AOCrafterDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~AOCrafterDialog();

    QLabel* ProcGrpLabel;
    QLabel* ProcessLabel;
    QLabel* QualityLabel;
    QComboBox* ProcGrpList;
    QComboBox* ProcessList;
	QSlider* QualitySlider;
	QSpinBox* QualitySpin;
	QPushButton* MaxQLButton;
    QPushButton* GoButton;
	QTabWidget* ResultCtrl;
	QLabel* NoResultLabel;
	QScrollView* StepView;
	QVBox* StepsList;
	QVBox* SummaryBox;
	QVBox* ItemsBox;
	QScrollView* ItemsView;
	QGrid* ItemsList;
	QLabel* NoteLabel;
	QVBox* SkillsBox;
	QScrollView* SkillsView;
	QGrid* SkillsList;
    QPushButton* PrefsButton;
    QPushButton* ExitButton;

protected slots:
    virtual void goClicked();
    virtual void prefsClicked();
	virtual void maxQLToggled(bool);
    virtual void procGrpChanged(int);
    virtual void processChanged(int);
	virtual void qualityChanged(int);

	void updateProcGrpList();
	void updateProcList();
	void calcSet();
	void calcMax();
	void showResults();

protected:
    QVBoxLayout* BaseLayout;
    QVBoxLayout* ItemsBoxLayout;
	QHBoxLayout* ItemsHeadLayout;
    QVBoxLayout* SkillsBoxLayout;
    QHBoxLayout* Layout1;
    QGridLayout* Layout4;
    bool event( QEvent* );

	ReqsList Items;
	ReqsList Skills;
	StepList Steps;
};


class AOCStepWidget : public QVBox
{ 
    Q_OBJECT

public:
    AOCStepWidget( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~AOCStepWidget();

	void setStep( AOCStep Step, int n );

protected:
	QGrid* StepBox;
	QLabel* StepLabel;
	QLabel* SourceLabel;
	QLabel* SourceQlLabel;
	QLabel* TargetLabel;
	QLabel* TargetQlLabel;
	QLabel* ResultLabel;
	QLabel* ResultQlLabel;
	QLabel* NoteLabel;

	QGrid* SkillsBox;
};

#endif // CLIENT_DLG_H
