/****************************************************************************
** Form implementation generated from reading ui file '.\AOCrafterItemDialog.ui'
**
** Created: Fri Oct 10 18:13:37 2003
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "item_dlg.h"

#include <qspinbox.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

#include "../pixmaps/AOCrafter.xpm"

/* 
 *  Constructs a AOCrafterItemDialogBase which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
AOCrafterItemDialog::AOCrafterItemDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "AOCrafterItemDialog" );
    resize( 240, 80 ); 
    setCaption( tr( "AOCrafter - Admin" ) );
	setIcon( QPixmap( AOCrafter_xpm ) );
    AOCrafterItemDialogLayout = new QVBoxLayout( this ); 
    AOCrafterItemDialogLayout->setSpacing( 4 );
    AOCrafterItemDialogLayout->setMargin( 6 );

    MainFrame = new QFrame( this, "MainFrame" );
    MainFrame->setFrameShape( QFrame::Box );
    MainFrame->setFrameShadow( QFrame::Sunken );
    MainFrameLayout = new QGridLayout( MainFrame ); 
    MainFrameLayout->setSpacing( 4 );
    MainFrameLayout->setMargin( 6 );

    NameLabel = new QLabel( MainFrame, "NameLabel" );
    NameLabel->setText( tr( "&Name" ) );

    MainFrameLayout->addWidget( NameLabel, 0, 0 );

    NameEdit = new QLineEdit( MainFrame, "NameEdit" );

    MainFrameLayout->addMultiCellWidget( NameEdit, 0, 0, 1, 2 );

	MinQlLabel = new QLabel( MainFrame, "MinQlLabel" );
	MinQlLabel->setText( tr( "Min QL" ) );
	MainFrameLayout->addWidget( MinQlLabel, 1, 0 );

	MinQlSpin = new QSpinBox( MainFrame, "MinQlSpin" );
	MinQlSpin->setMaxValue( 999 );
	MinQlSpin->setMinValue( 1 );
	MinQlSpin->setValue( 1 );
	MainFrameLayout->addWidget( MinQlSpin, 1, 1 );

	MaxQlLabel = new QLabel( MainFrame, "MaxQlLabel" );
	MaxQlLabel->setText( tr( "Max QL" ) );
	MainFrameLayout->addWidget( MaxQlLabel, 2, 0 );

	MaxQlSpin = new QSpinBox( MainFrame, "MaxQlSpin" );
	MaxQlSpin->setMaxValue( 999 );
	MaxQlSpin->setMinValue( 1 );
	MaxQlSpin->setValue( 200 );
	MainFrameLayout->addWidget( MaxQlSpin, 2, 1 );

	SpecialBox = new QCheckBox( MainFrame, "SpecialBox" );
	SpecialBox->setText( tr( "&Special" ) );
	SpecialBox->setChecked( FALSE );
	MainFrameLayout->addMultiCellWidget( SpecialBox, 1, 2, 2, 2 );

	AOdbLabel = new QLabel( MainFrame, "AOdbLabel" );
	AOdbLabel->setText( tr( "&aodb.info ID" ) );

	MainFrameLayout->addWidget( AOdbLabel, 3, 0 );

	AOdbEdit = new QLineEdit( MainFrame, "AOdbEdit" );
	AOdbEdit->setText( "0" );

	MainFrameLayout->addMultiCellWidget( AOdbEdit, 3, 3, 1, 2 );

    Layout1 = new QHBoxLayout;
    Layout1->setSpacing( 6 );
    Layout1->setMargin( 0 );

    OkBtn = new QPushButton( MainFrame, "OkBtn" );
    OkBtn->setText( tr( "&OK" ) );
    OkBtn->setAutoDefault( TRUE );
    OkBtn->setDefault( TRUE );
    Layout1->addWidget( OkBtn );

    CancelBtn = new QPushButton( MainFrame, "CancelBtn" );
    CancelBtn->setText( tr( "&Cancel" ) );
    CancelBtn->setAutoDefault( TRUE );
    Layout1->addWidget( CancelBtn );

    MainFrameLayout->addMultiCellLayout( Layout1, 4, 4, 0, 2 );
	AOCrafterItemDialogLayout->addWidget( MainFrame );

    // signals and slots connections
    connect( OkBtn, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( CancelBtn, SIGNAL( clicked() ), this, SLOT( reject() ) );
	connect( SpecialBox, SIGNAL( toggled(bool) ), this, SLOT( setSpecial(bool) ) );

    // buddies
    NameLabel->setBuddy( NameEdit );
    MinQlLabel->setBuddy( MinQlSpin );
    MaxQlLabel->setBuddy( MaxQlSpin );
	AOdbLabel->setBuddy( AOdbEdit );

	NameEdit->setFocus();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
AOCrafterItemDialog::~AOCrafterItemDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

void AOCrafterItemDialog::setSpecial( bool checked )
{
	MaxQlSpin->setEnabled( !checked );
	SpecialBox->setChecked( checked );
}
