/****************************************************************************
** Form interface generated from reading ui file 'ui_files\step_dlg.ui'
**
** Created: Thu Jan 22 17:07:21 2004
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#ifndef STEP_DLG_H
#define STEP_DLG_H

#include <qvariant.h>
#include <qdialog.h>
#include "../common/aoc_proc.h"
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QCheckBox;
class QComboBox;
class QFrame;
class QGroupBox;
class QLabel;
class QLineEdit;
class QListView;
class QListViewItem;
class QPushButton;
class QMultiLineEdit;
class QSpinBox;

class AOCStepDialog : public QDialog
{ 
	Q_OBJECT

public:
	AOCStepDialog( ItemList items, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~AOCStepDialog();

	AOCStep Step;
	void updateData();

protected slots:
	virtual void addItem();
	virtual void deleteSkill();
	virtual void editSource();
	virtual void editTarget();
	virtual void editResult();
	virtual void editSkill();
	virtual void setFixed(bool);
	virtual void setCount(int);
	virtual void saveNote();
	virtual void clearNote();

protected:
	QGridLayout* StepDialogLayout;

	QHBoxLayout* ItemsLayout;
	QGroupBox* SourceBox;
	QVBoxLayout* SourceBoxLayout;
	QLabel* SourceNameLabel;
	QLabel* SourceQlLabel;
	QLabel* SourceFlagsLabel;
	QPushButton* SourceEditBtn;
	QLabel* AddLabel;
	QGroupBox* TargetBox;
	QVBoxLayout* TargetBoxLayout;
	QLabel* TargetNameLabel;
	QLabel* TargetQlLabel;
	QLabel* TargetFlagsLabel;
	QPushButton* TargetEditBtn;
	QLabel* ResultLabel;
	QGroupBox* ResultBox;
	QVBoxLayout* ResultBoxLayout;
	QLabel* ResultNameLabel;
	QLabel* ResultQlLabel;
	QPushButton* ResultEditBtn;

	QGroupBox* SkillBox;
	QVBoxLayout* SkillBoxLayout;
	QListView* SkillsList;
	QHBoxLayout* SkillsLayout;
	QPushButton* SkillEditBtn;
	QPushButton* SkillDelBtn;

	QGroupBox* EditFrame;
	QGridLayout* EditFrameLayout;
	QLabel* NameLabel;
	QComboBox* NameBox;
	QLabel* MultiLabel;
	QLineEdit* MultiEdit;
	QCheckBox* FixedBox;
	QHBoxLayout* FlagsLayout;
	QCheckBox* ConsumedBox;
	QCheckBox* ResourceBox;
	QCheckBox* Flag3Box;
	QPushButton* AddBtn;

	QGroupBox* NoteBox;
	QGridLayout* NoteBoxLayout;
	QMultiLineEdit* NoteEdit;
	QPushButton* NoteSaveBtn;
	QPushButton* NoteClearBtn;

	QHBoxLayout* SysLayout;
	QLabel* CountLabel;
	QSpinBox* CountBox;
	QPushButton* AcceptBtn;
	QPushButton* CancelBtn;

	enum EditModes {
		AddSkill	= 0x0000,
		EditSkill	= 0x0001,
		EditSource	= 0x0002,
		EditTarget	= 0x0003,
		EditResult	= 0x0004
	};

	int getItemIndexByID(Q_UINT32);
	AOCItem getItemByIndex(int);
	AOCItem getItemByID(Q_UINT32);
	void listItems(bool);

	EditModes EditMode;
	ItemList AvailItems;
	int selSkill;
};

#endif // STEP_DLG_H
