#include <qapplication.h>
#include <qplatinumstyle.h>
#include "client_dlg.h"
#include "../common/aoc_proc.h"
#include "../common/aoc_names.h"
#include "skills.h"

AOCProcData Procs;
AOCNames Names;
AOCMySkills MySkills;

int main( int argc, char** argv )
{
	QApplication app( argc, argv );
	
	app.setStyle( new QPlatinumStyle );

	AOCrafterDialog dialog( 0, 0, TRUE, Qt::WStyle_Customize | Qt::WStyle_DialogBorder | Qt::WStyle_Title | Qt::WStyle_SysMenu | Qt::WStyle_ContextHelp );
	app.setMainWidget(&dialog);

	dialog.exec();

	MySkills.saveData();

	return 0;
}
