/****************************************************************************
** Form implementation generated from reading ui file 'ui-files\prefs_dlg.ui'
**
** Created: Wed Sep 29 17:06:28 2004
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "prefs_dlg.h"
#include "about_dlg.h"
#include "skill_dlg.h"

#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

#include "../pixmaps/AOCrafter.xpm"

/* 
 *  Constructs a AOCPrefsDlg which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
AOCPrefsDlg::AOCPrefsDlg( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
		setName( "AOCPrefsDlg" );
    resize( 480, 355 ); 
    setCaption( tr( "AOCrafter - Preferences" ) );
    QPixmap *icon = new QPixmap( AOCrafter_xpm );
    setIcon( *icon );
    AOCPrefsDlgLayout = new QVBoxLayout( this ); 
    AOCPrefsDlgLayout->setSpacing( 4 );
    AOCPrefsDlgLayout->setMargin( 6 );

    PrefsCtrl = new QTabWidget( this, "PrefsCtrl" );

	/*
	 * Add Tabs here:
	 * Best solution is to make separate dialogs for each tab,
	 * and convert those QDialog's to QFrame's
	 */

	/* 'My Skills' dialog */
	AOCSkillDlg * SkillsTab = new AOCSkillDlg( this );
    PrefsCtrl->insertTab( SkillsTab, tr( "My Skills" ) );

	/* 'About' dialog - leave this last */
	AOCAboutDlg * AboutTab = new AOCAboutDlg( this );
    PrefsCtrl->insertTab( AboutTab, tr( "About..." ) );

    AOCPrefsDlgLayout->addWidget( PrefsCtrl );

    SysLayout = new QHBoxLayout; 
    SysLayout->setSpacing( 4 );
    SysLayout->setMargin( 0 );
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    SysLayout->addItem( spacer );

    OkBtn = new QPushButton( this, "OkBtn" );
    OkBtn->setText( tr( "&Ok" ) );
    SysLayout->addWidget( OkBtn );

    CancelBtn = new QPushButton( this, "CancelBtn" );
    CancelBtn->setText( tr( "&Cancel" ) );
    SysLayout->addWidget( CancelBtn );
    AOCPrefsDlgLayout->addLayout( SysLayout );

    // signals and slots connections
    connect( OkBtn, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( CancelBtn, SIGNAL( clicked() ), this, SLOT( reject() ) );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
AOCPrefsDlg::~AOCPrefsDlg()
{
    // no need to delete child widgets, Qt does it all for us
}

